Index: /LMDZ4/trunk/libf/phylmd/regr_lat_time_coefoz_m.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/regr_lat_time_coefoz_m.F90	(revision 1403)
+++ /LMDZ4/trunk/libf/phylmd/regr_lat_time_coefoz_m.F90	(revision 1403)
@@ -0,0 +1,357 @@
+! $Id$
+module regr_lat_time_coefoz_m
+
+  ! Author: Lionel GUEZ
+
+  implicit none
+
+  private
+  public regr_lat_time_coefoz
+
+contains
+
+  subroutine regr_lat_time_coefoz
+
+    ! "regr_lat_time_coefoz" stands for "regrid latitude time
+    ! coefficients ozone".
+
+    ! This procedure reads from a NetCDF file coefficients for ozone
+    ! chemistry, regrids them in latitude and time, and writes the
+    ! regridded fields to a new NetCDF file.
+
+    ! The input fields depend on time, pressure level and latitude.
+    ! We assume that the input fields are step functions of latitude.
+    ! Regridding in latitude is made by averaging, with a cosine of
+    ! latitude factor.
+    ! The target LMDZ latitude grid is the "scalar" grid: "rlatu".
+    ! The values of "rlatu" are taken to be the centers of intervals.
+    ! Regridding in time is by linear interpolation.
+    ! Monthly values are processed to get daily values, on the basis
+    ! of a 360-day calendar.
+
+    ! We assume that in the input file:
+    ! -- the latitude is in degrees and strictly monotonic (as all
+    ! NetCDF coordinate variables should be);
+    ! -- time increases from January to December (even though we do
+    ! not use values of the input time coordinate);
+    ! -- pressure is in hPa and in strictly ascending order (even
+    ! though we do not use pressure values here, we write the unit of
+    ! pressure in the NetCDF header, and we will use the assumptions later,
+    ! when we regrid in pressure).
+
+    use regr1_step_av_m, only: regr1_step_av
+    use regr3_lint_m, only: regr3_lint
+    use netcdf95, only: nf95_open, nf95_close, nf95_inq_varid, handle_err, &
+         nf95_put_var, nf95_gw_var
+    use netcdf, only: nf90_nowrite, nf90_get_var
+
+    ! Variables local to the procedure:
+
+    include "dimensions.h"
+    ! (for "jjm")
+    include "paramet.h"
+    include "comgeom2.h"
+    ! (for "rlatv")
+    include "comconst.h"
+    ! (for "pi")
+
+    integer ncid_in, ncid_out ! NetCDF IDs for input and output files
+    integer n_plev ! number of pressure levels in the input data
+    integer n_lat! number of latitudes in the input data
+
+    real, pointer:: latitude(:)
+    ! (of input data, converted to rad, sorted in strictly ascending order)
+
+    real, allocatable:: lat_in_edg(:)
+    ! (edges of latitude intervals for input data, in rad, in strictly
+    ! ascending order)
+
+    real, pointer:: plev(:) ! pressure level of input data
+    logical desc_lat ! latitude in descending order in the input file
+
+    real, allocatable:: o3_par_in(:, :, :) ! (n_lat, n_plev, 12)
+    ! (ozone parameter from the input file)
+    ! ("o3_par_in(j, l, month)" is at latitude "latitude(j)" and pressure
+    ! level "plev(l)". "month" is between 1 and 12.)
+
+    real, allocatable:: v_regr_lat(:, :, :) ! (jjm + 1, n_plev, 0:13)
+    ! (mean of a variable "v" over a latitude interval)
+    ! (First dimension is latitude interval.
+    ! The latitude interval for "v_regr_lat(j,:, :)" contains "rlatu(j)".
+    ! If "j" is between 2 and "jjm" then the interval is:
+    ! [rlatv(j), rlatv(j-1)]
+    ! If "j" is 1 or "jjm + 1" then the interval is:
+    ! [rlatv(1), pi / 2]
+    ! or:
+    ! [- pi / 2, rlatv(jjm)]
+    ! respectively.
+    ! "v_regr_lat(:, l, :)" is for pressure level "plev(l)".
+    ! Last dimension is month number.)
+
+    real, allocatable:: o3_par_out(:, :, :) ! (jjm + 1, n_plev, 360)
+    ! (regridded ozone parameter)
+    ! ("o3_par_out(j, l, day)" is at latitude "rlatu(j)", pressure
+    ! level "plev(l)" and date "January 1st 0h" + "tmidday(day)", in a
+    ! 360-day calendar.)
+
+    integer j
+    integer i_v ! index of ozone parameter
+    integer, parameter:: n_o3_param = 8 ! number of ozone parameters
+
+    character(len=11) name_in(n_o3_param)
+    ! (name of NetCDF primary variable in the input file)
+
+    character(len=9) name_out(n_o3_param)
+    ! (name of NetCDF primary variable in the output file)
+
+    integer varid_in(n_o3_param), varid_out(n_o3_param), varid_plev, varid_time
+    integer ncerr, varid
+    ! (for NetCDF)
+
+    real, parameter:: tmidmonth(0:13) = (/(-15. + 30. * j, j = 0, 13)/)
+    ! (time to middle of month, in days since January 1st 0h, in a
+    ! 360-day calendar)
+    ! (We add values -15 and 375 so that, for example, day 3 of the year is
+    ! interpolated between the December and the January value.)
+
+    real, parameter:: tmidday(360) = (/(j + 0.5, j = 0, 359)/)
+    ! (time to middle of day, in days since January 1st 0h, in a
+    ! 360-day calendar)
+
+    !---------------------------------
+
+    print *, "Call sequence information: regr_lat_time_coefoz"
+
+    ! Names of ozone parameters:
+    i_v = 0
+
+    i_v = i_v + 1
+    name_in(i_v) = "P_net"
+    name_out(i_v) = "P_net_Mob"
+
+    i_v = i_v + 1
+    name_in(i_v) = "a2"
+    name_out(i_v) = "a2"
+
+    i_v = i_v + 1
+    name_in(i_v) = "tro3"
+    name_out(i_v) = "r_Mob"
+
+    i_v = i_v + 1
+    name_in(i_v) = "a4"
+    name_out(i_v) = "a4"
+
+    i_v = i_v + 1
+    name_in(i_v) = "temperature"
+    name_out(i_v) = "temp_Mob"
+
+    i_v = i_v + 1
+    name_in(i_v) = "a6"
+    name_out(i_v) = "a6"
+
+    i_v = i_v + 1
+    name_in(i_v) = "Sigma"
+    name_out(i_v) = "Sigma_Mob"
+
+    i_v = i_v + 1
+    name_in(i_v) = "R_Het"
+    name_out(i_v) = "R_Het"
+
+    call nf95_open("coefoz.nc", nf90_nowrite, ncid_in)
+
+    ! Get coordinates from the input file:
+
+    call nf95_inq_varid(ncid_in, "latitude", varid)
+    call nf95_gw_var(ncid_in, varid, latitude)
+    ! Convert from degrees to rad, because "rlatv" is in rad:
+    latitude = latitude / 180. * pi
+    n_lat = size(latitude)
+    ! We need to supply the latitudes to "regr1_step_av" in
+    ! ascending order, so invert order if necessary:
+    desc_lat = latitude(1) > latitude(n_lat)
+    if (desc_lat) latitude = latitude(n_lat:1:-1)
+
+    ! Compute edges of latitude intervals:
+    allocate(lat_in_edg(n_lat + 1))
+    lat_in_edg(1) = - pi / 2
+    forall (j = 2:n_lat) lat_in_edg(j) = (latitude(j - 1) + latitude(j)) / 2
+    lat_in_edg(n_lat + 1) = pi / 2
+    deallocate(latitude) ! pointer
+
+    call nf95_inq_varid(ncid_in, "plev", varid)
+    call nf95_gw_var(ncid_in, varid, plev)
+    n_plev = size(plev)
+    ! (We only need the pressure coordinate to copy it to the output file.)
+
+    ! Get the IDs of ozone parameters in the input file:
+    do i_v = 1, n_o3_param
+       call nf95_inq_varid(ncid_in, trim(name_in(i_v)), varid_in(i_v))
+    end do
+
+    ! Create the output file and get the variable IDs:
+    call prepare_out(ncid_in, varid_in, n_plev, name_out, ncid_out, &
+         varid_out, varid_plev, varid_time)
+
+    ! Write remaining coordinate variables:
+    call nf95_put_var(ncid_out, varid_time, tmidday)
+    call nf95_put_var(ncid_out, varid_plev, plev)
+
+    deallocate(plev) ! pointer
+
+    allocate(o3_par_in(n_lat, n_plev, 12))
+    allocate(v_regr_lat(jjm + 1, n_plev, 0:13))
+    allocate(o3_par_out(jjm + 1, n_plev, 360))
+
+    do i_v = 1, n_o3_param
+       ! Process ozone parameter "name_in(i_v)"
+
+       ncerr = nf90_get_var(ncid_in, varid_in(i_v), o3_par_in)
+       call handle_err("nf90_get_var", ncerr, ncid_in)
+
+       if (desc_lat) o3_par_in = o3_par_in(n_lat:1:-1, :, :)
+
+       ! Regrid in latitude:
+       ! We average with respect to sine of latitude, which is
+       ! equivalent to weighting by cosine of latitude:
+       v_regr_lat(jjm+1:1:-1, :, 1:12) = regr1_step_av(o3_par_in, &
+            xs=sin(lat_in_edg), xt=sin((/- pi / 2, rlatv(jjm:1:-1), pi / 2/)))
+       ! (invert order of indices in "v_regr_lat" because "rlatu" is
+       ! in descending order)
+
+       ! Duplicate January and December values, in preparation of time
+       ! interpolation:
+       v_regr_lat(:, :, 0) = v_regr_lat(:, :, 12)
+       v_regr_lat(:, :, 13) = v_regr_lat(:, :, 1)
+
+       ! Regrid in time by linear interpolation:
+       o3_par_out = regr3_lint(v_regr_lat, tmidmonth, tmidday)
+
+       ! Write to file:
+       call nf95_put_var(ncid_out, varid_out(i_v), &
+            o3_par_out(jjm+1:1:-1, :, :))
+       ! (The order of "rlatu" is inverted in the output file)
+    end do
+
+    call nf95_close(ncid_out)
+    call nf95_close(ncid_in)
+
+  end subroutine regr_lat_time_coefoz
+
+  !********************************************
+
+  subroutine prepare_out(ncid_in, varid_in, n_plev, name_out, ncid_out, &
+       varid_out, varid_plev, varid_time)
+
+    ! This subroutine creates the NetCDF output file, defines
+    ! dimensions and variables, and writes one of the coordinate variables.
+
+    use assert_eq_m, only: assert_eq
+
+    use netcdf95, only: nf95_create, nf95_def_dim, nf95_def_var, &
+         nf95_put_att, nf95_enddef, nf95_copy_att, nf95_put_var
+    use netcdf, only: nf90_clobber, nf90_float, nf90_copy_att, nf90_global
+
+    integer, intent(in):: ncid_in, varid_in(:), n_plev
+    character(len=*), intent(in):: name_out(:) ! of NetCDF variables
+    integer, intent(out):: ncid_out, varid_out(:), varid_plev, varid_time
+
+    ! Variables local to the procedure:
+
+    include "dimensions.h"
+    ! (for "jjm")
+    include "paramet.h"
+    include "comgeom2.h"
+    ! (for "rlatu")
+    include "comconst.h"
+    ! (for "pi")
+
+    integer ncerr
+    integer dimid_rlatu, dimid_plev, dimid_time
+    integer varid_rlatu
+    integer i, n_o3_param
+
+    !---------------------------
+
+    print *, "Call sequence information: prepare_out"
+    n_o3_param = assert_eq(size(varid_in), size(varid_out), &
+         size(name_out), "prepare_out") 
+
+    call nf95_create("coefoz_LMDZ.nc", nf90_clobber, ncid_out)
+
+    ! Dimensions:
+    call nf95_def_dim(ncid_out, "time", 360, dimid_time)
+    call nf95_def_dim(ncid_out, "plev", n_plev, dimid_plev)
+    call nf95_def_dim(ncid_out, "rlatu", jjm + 1, dimid_rlatu)
+
+    ! Define coordinate variables:
+
+    call nf95_def_var(ncid_out, "time", nf90_float, dimid_time, varid_time)
+    call nf95_put_att(ncid_out, varid_time, "units", "days since 2000-1-1")
+    call nf95_put_att(ncid_out, varid_time, "calendar", "360_day")
+    call nf95_put_att(ncid_out, varid_time, "standard_name", "time")
+
+    call nf95_def_var(ncid_out, "plev", nf90_float, dimid_plev, varid_plev)
+    call nf95_put_att(ncid_out, varid_plev, "units", "millibar")
+    call nf95_put_att(ncid_out, varid_plev, "standard_name", "air_pressure")
+    call nf95_put_att(ncid_out, varid_plev, "long_name", "air pressure")
+
+    call nf95_def_var(ncid_out, "rlatu", nf90_float, dimid_rlatu, varid_rlatu)
+    call nf95_put_att(ncid_out, varid_rlatu, "units", "degrees_north")
+    call nf95_put_att(ncid_out, varid_rlatu, "standard_name", "latitude")
+
+    ! Define primary variables:
+
+    do i = 1, n_o3_param
+       call nf95_def_var(ncid_out, name_out(i), nf90_float, &
+            (/dimid_rlatu, dimid_plev, dimid_time/), varid_out(i))
+
+       ! The following commands may fail. That is OK. It should just
+       ! mean that the attribute is not defined in the input file.
+
+       ncerr = nf90_copy_att(ncid_in, varid_in(i), "long_name",&
+            & ncid_out, varid_out(i))
+       call handle_err_copy_att("long_name")
+
+       ncerr = nf90_copy_att(ncid_in, varid_in(i), "units", ncid_out,&
+            & varid_out(i))
+       call handle_err_copy_att("units")
+
+       ncerr = nf90_copy_att(ncid_in, varid_in(i), "standard_name", ncid_out,&
+            & varid_out(i))
+       call handle_err_copy_att("standard_name")
+    end do
+
+    ! Global attributes:
+    call nf95_copy_att(ncid_in, nf90_global, "Conventions", ncid_out, &
+         nf90_global)
+    call nf95_copy_att(ncid_in, nf90_global, "title", ncid_out, nf90_global)
+    call nf95_copy_att(ncid_in, nf90_global, "source", ncid_out, nf90_global)
+    call nf95_put_att(ncid_out, nf90_global, "comment", "Regridded for LMDZ")
+
+    call nf95_enddef(ncid_out)
+
+    ! Write one of the coordinate variables:
+    call nf95_put_var(ncid_out, varid_rlatu, rlatu(jjm+1:1:-1) / pi * 180.)
+    ! (convert from rad to degrees and sort in ascending order)
+
+  contains
+
+    subroutine handle_err_copy_att(att_name)
+
+      use netcdf, only: nf90_noerr, nf90_strerror
+
+      character(len=*), intent(in):: att_name
+
+      !----------------------------------------
+
+      if (ncerr /= nf90_noerr) then
+         print *, "prepare_out " // trim(name_out(i)) &
+              // " nf90_copy_att " // att_name // " -- " &
+              // trim(nf90_strerror(ncerr))
+      end if
+
+    end subroutine handle_err_copy_att
+
+  end subroutine prepare_out
+
+end module regr_lat_time_coefoz_m
Index: /LMDZ4/trunk/libf/phylmd/regr_pr_av_m.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/regr_pr_av_m.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/regr_pr_av_m.F90	(revision 1403)
@@ -21,7 +21,7 @@
     ! latitude, pressure, julian day.
     ! We assume that the input fields are already on the "rlatu"
-    ! latitudes, excepth that latitudes are in ascending order in the input
+    ! latitudes, except that latitudes are in ascending order in the input
     ! file.
-    ! We assume that the inputs fields have the same pressure coordinate.
+    ! We assume that all the inputs fields have the same coordinates.
 
     ! The target vertical LMDZ grid is the grid of layer boundaries.
@@ -91,10 +91,11 @@
     if (is_mpi_root) then
        do i = 1, n_var
-          call nf95_inq_varid(ncid, name(i), varid)
+          call nf95_inq_varid(ncid, trim(name(i)), varid)
           
           ! Get data at the right day from the input file:
           ncerr = nf90_get_var(ncid, varid, v1(1, :, :, i), &
                start=(/1, 1, julien/))
-          call handle_err("regr_pr_av nf90_get_var " // name(i), ncerr, ncid)
+          call handle_err("regr_pr_av nf90_get_var " // trim(name(i)), ncerr, &
+               ncid)
        end do
        
Index: /LMDZ4/trunk/libf/phylmd/regr_pr_comb_coefoz_m.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/regr_pr_comb_coefoz_m.F90	(revision 1403)
+++ /LMDZ4/trunk/libf/phylmd/regr_pr_comb_coefoz_m.F90	(revision 1403)
@@ -0,0 +1,163 @@
+! $Id$
+module regr_pr_comb_coefoz_m
+
+  implicit none
+
+  ! The five module variables declared here are on the partial
+  ! "physics" grid.
+  ! The value of each variable for index "(i, k)" is at longitude
+  ! "rlon(i)", latitude "rlat(i)" and middle of layer "k".
+
+  real, allocatable, save:: c_Mob(:, :)
+  ! (sum of Mobidic terms in the net mass production rate of ozone
+  ! by chemistry, per unit mass of air, in s-1)
+
+  real, allocatable, save:: a2(:, :)
+  ! (derivative of mass production rate of ozone per unit mass of
+  ! air with respect to ozone mass fraction, in s-1)
+
+  real, allocatable, save:: a4_mass(:, :)
+  ! (derivative of mass production rate of ozone per unit mass of
+  ! air with respect to temperature, in s-1 K-1)
+
+  real, allocatable, save:: a6_mass(:, :)
+  ! (derivative of mass production rate of ozone per unit mass of
+  ! air with respect to mass column-density of ozone above, in m2 s-1 kg-1)
+
+  real, allocatable, save:: r_het_interm(:, :)
+  ! (net mass production rate by heterogeneous chemistry, per unit
+  ! mass of ozone, corrected for chlorine content and latitude, but
+  ! not for temperature and sun direction, in s-1)
+
+  !$omp threadprivate(c_Mob, a2, a4_mass, a6_mass, r_het_interm)
+
+contains
+
+  subroutine alloc_coefoz
+
+    ! This procedure is called once per run.
+    ! It allocates module variables.
+
+    use dimphy, only: klon
+
+    ! Variables local to the procedure:
+    include "dimensions.h"
+
+    !---------------------------------------
+
+    !$omp master
+    print *, "Call sequence information: alloc_coefoz"
+    !$omp end master
+    allocate(c_Mob(klon, llm), a2(klon, llm), a4_mass(klon, llm))
+    allocate(a6_mass(klon, llm), r_het_interm(klon, llm))
+
+  end subroutine alloc_coefoz
+
+  !*******************************************************
+
+  subroutine regr_pr_comb_coefoz(julien, rlat, paprs, pplay)
+
+    ! "regr_pr_comb_coefoz" stands for "regrid pressure combine
+    ! coefficients ozone".
+
+    ! In this subroutine:
+    ! -- the master thread of the root process reads from a file all
+    !    eight coefficients for ozone chemistry, at the current day;
+    ! -- the coefficients are packed to the "physics" horizontal grid
+    !    and scattered to all threads of all processes;
+    ! -- in all the threads of all the processes, the coefficients are
+    !    regridded in pressure to the LMDZ vertical grid;
+    ! -- in all the threads of all the processes, the eight
+    !    coefficients are combined to define the five module variables.
+
+    use netcdf95, only: nf95_open, nf95_close
+    use netcdf, only: nf90_nowrite
+    use assert_m, only: assert
+    use dimphy, only: klon
+    use mod_phys_lmdz_mpi_data, only: is_mpi_root
+    use regr_pr_av_m, only: regr_pr_av
+    use regr_pr_int_m, only: regr_pr_int
+    use press_coefoz_m, only: press_in_edg, plev
+
+    integer, intent(in):: julien ! jour julien, 1 <= julien <= 360
+
+    REAL, intent(in):: rlat(:)
+    ! (latitude on the partial "physics" grid, in degrees)
+
+    real, intent(in):: paprs(:, :) ! (klon, llm + 1)
+    ! (pression pour chaque inter-couche, en Pa)
+
+    real, intent(in):: pplay(:, :) ! (klon, llm)
+    ! (pression pour le mileu de chaque couche, en Pa)
+
+    ! Variables local to the procedure:
+
+    include "dimensions.h"
+    integer ncid ! for NetCDF
+
+    real coefoz(klon, llm, 7)
+    ! (temporary storage for 7 ozone coefficients)
+    ! (On the partial "physics" grid.
+    ! "coefoz(i, k, :)" is at longitude "rlon(i)", latitude "rlat(i)",
+    ! middle of layer "k".)
+
+    real a6(klon, llm)
+    ! (derivative of "P_net_Mob" with respect to column-density of ozone
+    ! above, in cm2 s-1)
+    ! (On the partial "physics" grid.
+    ! "a6(i, k)" is at longitude "rlon(i)", latitude "rlat(i)",
+    ! middle of layer "k".)
+
+    real, parameter:: amu = 1.6605402e-27 ! atomic mass unit, in kg
+
+    real, parameter:: Clx = 3.8e-9
+    ! (total chlorine content in the upper stratosphere)
+
+    integer k
+
+    !------------------------------------
+
+    !!print *, "Call sequence information: regr_pr_comb_coefoz"
+    call assert((/size(rlat), size(paprs, 1), size(pplay, 1)/) == klon, &
+         "regr_pr_comb_coefoz klon")
+    call assert((/size(paprs, 2) - 1, size(pplay, 2)/) == llm, &
+         "regr_pr_comb_coefoz llm")
+
+    !$omp master
+    if (is_mpi_root) call nf95_open("coefoz_LMDZ.nc", nf90_nowrite, ncid)
+    !$omp end master
+
+    call regr_pr_av(ncid, (/"a2       ", "a4       ", "a6       ", &
+         "P_net_Mob", "r_Mob    ", "temp_Mob ", "R_Het    "/), julien, &
+         press_in_edg, paprs, coefoz)
+    a2 = coefoz(:, :, 1)
+    a4_mass = coefoz(:, :, 2) * 48. / 29.
+
+    ! Compute "a6_mass" avoiding underflow, do not divide by 1e4
+    ! before dividing by molecular mass:
+    a6_mass = coefoz(:, :, 3) / (1e4 * 29. * amu)
+    ! (factor 1e4: conversion from cm2 to m2)
+
+    ! We can overwrite "coefoz(:, :, 1)", which was saved to "a2":
+    call regr_pr_int(ncid, "Sigma_Mob", julien, plev, pplay, top_value=0., &
+         v3=coefoz(:, :, 1))
+
+    ! Combine coefficients to get "c_Mob":
+    c_mob = (coefoz(:, :, 4) - a2 * coefoz(:, :, 5) &
+         - coefoz(:, :, 3) * coefoz(:, :, 1)) * 48. / 29. &
+         - a4_mass * coefoz(:, :, 6)
+
+    r_het_interm = coefoz(:, :, 7)
+    ! Heterogeneous chemistry is only at high latitudes:
+    forall (k = 1: llm)
+       where (abs(rlat) <= 45.) r_het_interm(:, k) = 0.
+    end forall
+    r_het_interm = r_het_interm * (Clx / 3.8e-9)**2
+
+    !$omp master
+    if (is_mpi_root) call nf95_close(ncid)
+    !$omp end master
+
+  end subroutine regr_pr_comb_coefoz
+
+end module regr_pr_comb_coefoz_m
Index: /LMDZ4/trunk/libf/phylmd/regr_pr_o3_m.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/regr_pr_o3_m.F90	(revision 1403)
+++ /LMDZ4/trunk/libf/phylmd/regr_pr_o3_m.F90	(revision 1403)
@@ -0,0 +1,103 @@
+! $Id$
+module regr_pr_o3_m
+
+  implicit none
+
+contains
+
+  subroutine regr_pr_o3(p3d, o3_mob_regr)
+
+    ! "regr_pr_o3" stands for "regrid pressure ozone".
+    ! This procedure reads Mobidic ozone mole fraction from
+    ! "coefoz_LMDZ.nc" at the initial day of the run and regrids it in
+    ! pressure.
+    ! Ozone mole fraction from "coefoz_LMDZ.nc" at the initial day is
+    ! a 2D latitude -- pressure variable.
+    ! The target horizontal LMDZ grid is the "scalar" grid: "rlonv", "rlatu".
+    ! The target vertical LMDZ grid is the grid of layer boundaries.
+    ! We assume that the input variable is already on the LMDZ "rlatu"
+    ! latitude grid.
+    ! The input variable does not depend on longitude, but the
+    ! pressure at LMDZ layers does.
+    ! Therefore, the values on the LMDZ grid do depend on longitude.
+    ! Regridding is by averaging, assuming a step function.
+    ! We assume that, in the input file, the pressure levels are in
+    ! hPa and strictly increasing.
+
+    use netcdf95, only: nf95_open, nf95_close, nf95_inq_varid, handle_err
+    use netcdf, only:  nf90_nowrite, nf90_get_var
+    use assert_m, only: assert
+    use regr1_step_av_m, only: regr1_step_av
+    use press_coefoz_m, only: press_in_edg
+    use control_mod, only: dayref
+
+    REAL, intent(in):: p3d(:, :, :) ! pressure at layer interfaces, in Pa
+    ! ("p3d(i, j, l)" is at longitude "rlonv(i)", latitude "rlatu(j)",
+    ! for interface "l")
+
+    real, intent(out):: o3_mob_regr(:, :, :) ! (iim + 1, jjm + 1, llm)
+    ! (ozone mole fraction from Mobidic adapted to the LMDZ grid)
+    ! ("o3_mob_regr(i, j, l)" is at longitude "rlonv(i)", latitude
+    ! "rlatu(j)" and pressure level "pls(i, j, l)")
+
+    ! Variables local to the procedure:
+
+    include "dimensions.h"
+
+    integer ncid, varid, ncerr ! for NetCDF
+    integer i, j
+
+    real r_mob(jjm + 1, size(press_in_edg) - 1)
+    ! (ozone mole fraction from Mobidic at day "dayref")
+    ! (r_mob(j, k) is at latitude "rlatu(j)", in pressure interval
+    ! "[press_in_edg(k), press_in_edg(k+1)]".)
+
+    !------------------------------------------------------------
+
+    print *, "Call sequence information: regr_pr_o3"
+    call assert(shape(o3_mob_regr) == (/iim + 1, jjm + 1, llm/), &
+         "regr_pr_o3 o3_mob_regr")
+    call assert(shape(p3d) == (/iim + 1, jjm + 1, llm + 1/), "regr_pr_o3 p3d")
+
+    call nf95_open("coefoz_LMDZ.nc", nf90_nowrite, ncid)
+
+    call nf95_inq_varid(ncid, "r_Mob", varid)
+    ! Get data at the right day from the input file:
+    ncerr = nf90_get_var(ncid, varid, r_mob, start=(/1, 1, dayref/))
+    call handle_err("nf90_get_var r_Mob", ncerr)
+    ! Latitudes are in ascending order in the input file while
+    ! "rlatu" is in descending order so we need to invert order:
+    r_mob = r_mob(jjm+1:1:-1, :)
+
+    call nf95_close(ncid)
+
+    ! Regrid in pressure by averaging a step function of pressure:
+
+    ! Poles:
+    do j = 1, jjm + 1, jjm
+       o3_mob_regr(1, j, llm:1:-1) &
+            = regr1_step_av(r_mob(j, :), press_in_edg, p3d(1, j, llm+1:1:-1))
+       ! (invert order of indices because "p3d" is in descending order)
+    end do
+
+    ! Other latitudes:
+    do j = 2, jjm
+       do i = 1, iim
+          o3_mob_regr(i, j, llm:1:-1) &
+               = regr1_step_av(r_mob(j, :), press_in_edg, &
+               p3d(i, j, llm+1:1:-1))
+             ! (invert order of indices because "p3d" is in descending order)
+       end do
+    end do
+
+    ! Duplicate pole values on all longitudes:
+    o3_mob_regr(2:, 1, :) = spread(o3_mob_regr(1, 1, :), dim=1, ncopies=iim)
+    o3_mob_regr(2:, jjm + 1, :) &
+         = spread(o3_mob_regr(1, jjm + 1, :), dim=1, ncopies=iim)
+
+    ! Duplicate first longitude to last longitude:
+    o3_mob_regr(iim + 1, 2:jjm, :) = o3_mob_regr(1, 2:jjm, :)
+
+  end subroutine regr_pr_o3
+
+end module regr_pr_o3_m
Index: /LMDZ4/trunk/libf/phylmd/surf_landice_mod.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/surf_landice_mod.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/surf_landice_mod.F90	(revision 1403)
@@ -186,4 +186,14 @@
        ENDDO
 
+!****************************************************************************************
+       snow_o=0.
+       zfra_o = 0.
+       DO j = 1, knon
+           i = knindex(j)
+           snow_o(i) = snow(j)
+           zfra_o(i) = zfra(j)
+       ENDDO
+
+
   END SUBROUTINE surf_landice
 !
Index: /LMDZ4/trunk/libf/phylmd/surf_ocean_mod.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/surf_ocean_mod.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/surf_ocean_mod.F90	(revision 1403)
@@ -141,5 +141,5 @@
 !****************************************************************************************
     IF ( MINVAL(rmu0) == MAXVAL(rmu0) .AND. MINVAL(rmu0) == -999.999 ) THEN
-       CALL alboc(FLOAT(jour),rlat,alb_eau)
+       CALL alboc(REAL(jour),rlat,alb_eau)
     ELSE  ! diurnal cycle
        CALL alboc_cd(rmu0,alb_eau)
Index: /LMDZ4/trunk/libf/phylmd/thermcell.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/thermcell.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/thermcell.F	(revision 1403)
@@ -1,2 +1,5 @@
+!
+! $Id$
+!
       SUBROUTINE calcul_sec(ngrid,nlay,ptimestep
      s                  ,pplay,pplev,pphi,zlev
@@ -132,4 +135,8 @@
       character*10 str10
 
+      character (len=20) :: modname='calcul_sec'
+      character (len=80) :: abort_message
+
+
 !      LOGICAL vtest(klon),down
 
@@ -530,5 +537,5 @@
 c      write(8,*)zmax(ig),lmax(ig),lentr(ig),lmin(ig)
       enddo
-con stoppe après les calculs de zmax et wmax
+con stope après les calculs de zmax et wmax
       RETURN
 
@@ -776,5 +783,7 @@
          do ig=1,ngrid
             if(fracd(ig,l).lt.0.1) then
-               stop'fracd trop petit'
+              abort_message = 'fracd trop petit'
+              CALL abort_gcm (modname,abort_message,1)
+
             else
 c    vitesse descendante "diagnostique"
@@ -860,6 +869,6 @@
 cRC
       if (w2di.eq.1) then
-         fm0=fm0+ptimestep*(fm-fm0)/float(tho)
-         entr0=entr0+ptimestep*(entr-entr0)/float(tho)
+         fm0=fm0+ptimestep*(fm-fm0)/REAL(tho)
+         entr0=entr0+ptimestep*(entr-entr0)/REAL(tho)
       else
          fm0=fm
